diff -r fa91b35bee71 src/__control_helper_functions__.cc
--- a/src/__control_helper_functions__.cc	Fri May 04 04:10:35 2018 +0200
+++ b/src/__control_helper_functions__.cc	Sat Dec 29 18:38:45 2018 +0100
@@ -6,7 +6,7 @@
 #include "is_zp_vector.cc"
 #include "lti_input_idx.cc"
 
-#include "nfields2.cc"  // delete this if support for Octave 3.8 gets dropped
+// #include "nfields2.cc"  // delete this if support for Octave 3.8 gets dropped
 
 
 
diff -r fa91b35bee71 src/is_matrix.cc
--- a/src/is_matrix.cc	Fri May 04 04:10:35 2018 +0200
+++ b/src/is_matrix.cc	Sat Dec 29 18:38:45 2018 +0100
@@ -48,8 +48,9 @@
     {
         for (octave_idx_type i = 0; i < nargin; i++)
         {
-            if (args(i).ndims () != 2 || ! args(i).is_numeric_type ()
-                || ! (args(i).is_complex_type () || args(i).is_real_type ())
+            if (args(i).ndims () != 2 || ! args(i).isnumeric ()
+                || ! (args(i).iscomplex () || args(i).isreal ())
             {
                 retval = false;
                 break;
diff -r fa91b35bee71 src/is_real_matrix.cc
--- a/src/is_real_matrix.cc	Fri May 04 04:10:35 2018 +0200
+++ b/src/is_real_matrix.cc	Sat Dec 29 18:38:45 2018 +0100
@@ -48,8 +48,9 @@
     {
         for (octave_idx_type i = 0; i < nargin; i++)
         {
-            if (args(i).ndims () != 2 || ! args(i).is_numeric_type ()
-                || ! args(i).is_real_type ()
+            if (args(i).ndims () != 2 || ! args(i).isnumeric ()
+                || ! args(i).isreal ()
             {
                 retval = false;
                 break;
diff -r fa91b35bee71 src/is_real_scalar.cc
--- a/src/is_real_scalar.cc	Fri May 04 04:10:35 2018 +0200
+++ b/src/is_real_scalar.cc	Sat Dec 29 18:38:45 2018 +0100
@@ -49,7 +49,8 @@
         for (octave_idx_type i = 0; i < nargin; i++)
         {
             if (args(i).ndims () != 2 || ! args(i).is_scalar_type ()
-                || ! args(i).is_numeric_type () || ! args(i).is_real_type ()
+                || ! args(i).isnumeric () || ! args(i).isreal ()
             {
                 retval = false;
                 break;
diff -r fa91b35bee71 src/is_real_square_matrix.cc
--- a/src/is_real_square_matrix.cc	Fri May 04 04:10:35 2018 +0200
+++ b/src/is_real_square_matrix.cc	Sat Dec 29 18:38:45 2018 +0100
@@ -49,7 +49,8 @@
         for (octave_idx_type i = 0; i < nargin; i++)
         {
             if (args(i).ndims () != 2 || args(i).rows () != args(i).columns ()
-                || ! args(i).is_numeric_type () || ! args(i).is_real_type ()
+                || ! args(i).isnumeric () || ! args(i).isreal ()
             {
                 retval = false;
                 break;
diff -r fa91b35bee71 src/is_real_vector.cc
--- a/src/is_real_vector.cc	Fri May 04 04:10:35 2018 +0200
+++ b/src/is_real_vector.cc	Sat Dec 29 18:38:45 2018 +0100
@@ -49,7 +49,8 @@
         for (octave_idx_type i = 0; i < nargin; i++)
         {
             if (args(i).ndims () != 2 || ! (args(i).rows () == 1 || args(i).columns () == 1)
-                || ! args(i).is_numeric_type () || ! args(i).is_real_type ()
+                || ! args(i).isnumeric () || ! args(i).isreal ()
             {
                 retval = false;
                 break;
diff -r fa91b35bee71 src/is_zp_vector.cc
--- a/src/is_zp_vector.cc	Fri May 04 04:10:35 2018 +0200
+++ b/src/is_zp_vector.cc	Sat Dec 29 18:38:45 2018 +0100
@@ -50,8 +50,9 @@
         {
             if (args(i).ndims () != 2
                 || (args(i).rows () > 1 && args(i).columns () > 1)
-                || ! args(i).is_numeric_type ()
-                || ! (args(i).is_complex_type () || args(i).is_real_type ())
+                || ! args(i).isnumeric ()
+                || ! (args(i).iscomplex () || args(i).isreal ())
             {
                 retval = false;
                 break;
diff -r fa91b35bee71 src/lti_input_idx.cc
--- a/src/lti_input_idx.cc	Fri May 04 04:10:35 2018 +0200
+++ b/src/lti_input_idx.cc	Sat Dec 29 18:38:45 2018 +0100
@@ -60,7 +60,7 @@
   octave_idx_type nargin = args.length ();
 
   // first, check whether a cell is passed
-  if (nargin == 1 && args(0).is_defined () && args(0).is_cell ())
+  if (nargin == 1 && args(0).is_defined () && args(0).iscell ())
   {
     octave_idx_type len = args(0).cell_value().numel();
     octave_idx_type idx = len;
@@ -87,7 +87,7 @@
     //    and after strings) are not recognized as objects.
     //      ss (a, b, ltisys, c, d, 'key', val, 'lti', ltisys)
     if (len > 0 && idx > 0
-        && args(0).cell_value().elem(idx-1).is_object ())
+        && args(0).cell_value().elem(idx-1).isobject ())
     {
       offset = 1;
     }